%define EGCS_VERSION 1.0.2
%define STDC_VERSION 2.8.0

Summary: Experimental GNU Compiler System
Name: egcs
Version: %{EGCS_VERSION}
Release: 9
Copyright: GPL
Group: Development/Languages
Source: egcs-%{EGCS_VERSION}.tar.gz
Patch0: egcs-1.0.2-libio.patch
Patch1: egcs-1.0.2-hjl.patch
Patch2: egcs-1.0.2-rth1.patch
Patch3: egcs-1.0.2-rth2.patch
Patch4: egcs-1.0.2-rth3.patch
Patch5: egcs-1.0.2-rth4.patch
Patch6: egcs-1.0.2-hjl2.patch
Patch7: egcs-1.0.2-jim.patch
Patch8: egcs-1.0.2-sparc.patch
Patch9: egcs-1.0.2-haifa.patch
Patch10: egcs-1.0.1-objcbackend.patch
Patch11: egcs-1.0.2-mips.patch
BuildRoot: /var/tmp/egcs-root
URL: http://egcs.cygnus.com/
%ifarch mipseb mipsel mips
Requires: binutils >= 2.8.1
%else
Requires: binutils >= 2.8.1.0.1
%endif
%ifnarch i386
Obsoletes: gcc
Provides: gcc cpp
%endif

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: egcs = %{EGCS_VERSION}
Obsoletes: gcc-c++
%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Summary: Objective C support for gcc
Group: Development/Languages
Requires: egcs = %{EGCS_VERSION}
Obsoletes: gcc-objc
%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%package g77
Summary: Fortran 77 support for gcc
Group: Development/Languages
Requires: egcs = %{EGCS_VERSION}
%description g77
This apckage adds support for compiling Fortran 77 programs with the GNU
compiler.

%package -n libstdc++
Summary: GNU c++ library
Group: Libraries
Version: %{STDC_VERSION}
%ifnarch i386
Obsoletes: libg++
%endif
%description -n libstdc++
This is the GNU implementation of the standard C++ libraries, along with
additional GNU tools.  This package includes the shared libraries
necessary to run C++ applications.

%package -n libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Version: %{STDC_VERSION}
Requires: libstdc++ = %{STDC_VERSION}
Obsoletes: libg++-devel
%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development.

%changelog
* Thu May 07 1998 Cristian Gafton <gafton@redhat.com>
- foxed broken cpp link

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- added a patch for the haifa sched from Jeff Law. Huge thanks!
- added a patch from Christopher Seawood to fix egcs-objc compilation
  problems
- disabled the /usr/bin/cc1obj link - it just makes things worse (half
  working)

* Tue May  5 1998 Jeff Johnson <jbj@redhat.com>
- Fix atexit proto on sparc.
- Make bootstrap-lean for the disk-space conscious.
- Configure sparc-redhat-linux-gnulibc1 on sparc.

* Mon Apr 20 1998 Cristian Gafton <gafton@redhat.com>
- added a symlink for cc1obj in /usr/bin - this way gcc works with objective
  C files
- added a patch from Jim Wilson to fix some regstack problems on x86

* Wed Apr 15 1998 Cristian Gafton <gafton@redhat.com>
- added another patch from HJL to fix some x86 code generation problems

* Tue Apr 14 1998 Cristian Gafton <gafton@redhat.com>
- added a new patch from hjl to fix a optimization problem
- rebuilt the package so that egcs is the default C++ and Fortran compiler
  also on Intel.
- libstdc++-devel obsoletes libg++-devel on all platforms
- added 4 patches from Richard Hederson: fortran index problem, bogus asm
  generation, code generation problem for Mozilla, profiling

* Tue Apr 07 1998 Cristian Gafton <gafton@redhat.com>
- gave up the idea of packaging the snapshot and started to package the
  1.0.2 with some patches.

* Sun Apr 05 1998 Cristian Gafton <gafton@redhat.com>
- updated egcs to the current version from the snapshot
- fixed libf2c.a problem so it does not conflict with f2c package on alpha

* Fri Apr 03 1998 Cristian Gafton <gafton@redhat.com>
- the hacks for making it work with gcc need to be done only on i386. On
  alpha and sparc egcs is THE compiler
- reworked the whole %files list so that we now have a source RPM that
  builds on both intel and alpha. 
- added a  patch from Richard Henderson to fix cvtlq problem on alpha

* Thu Apr 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to a recent snapshot version
- modified the spec file to cope with automatic snapshot RPM generation
- heavily reworked the %install to get a package that eventually will
  coexist with gcc without conflicts
- added --no-split to makeinfo for convenience

* Tue Dec 29 1997 Trent Jarvi <jarvi@ezlink.com>
- chased down initial glitches preventing alpha-linux from working.
- removed --enable-threads=posix per request of Elliot Lee <sopwith@cuc.edu>

* Mon Dec 08 1997 Christopher Seawood <cls@seawood.org>
- Added install-info to %post{un}
- Added minimum rev for binutils
- Made sure STL headers were installed in /usr/include/g++
- Added --enable-haifa
- Linked libstdc++.so against -lpthread
- Built using recommended separate objdir

* Tue Dec 02 1997 Elliot Lee <sopwith@cuc.edu>
- Took off egcs- prefix for /usr/bin/* files, seeing as this works
  well enough to be system compiler.
- Miscellaneous fixups for the release (make it do 'make bootstrap',
  etc. etc.)

* Wed Nov 26 1997 Elliot Lee <sopwith@cuc.edu>
- Updated version, split libstdc++ into a separate package, etc.

* Fri Nov 14 1997 Elliot Lee <sopwith@cuc.edu>
- Added dependencies
- Added "egcs-" to prefix all /usr/bin/* files.

%prep
%setup -q
%patch0 -p1 -b .libio
%patch1 -p1 -b .hjl
%patch2 -p1 -b .rth1
%patch3 -p1 -b .rth2
%patch4 -p1 -b .rth3
%patch5 -p1 -b .rth4
%patch6 -p1 -b .hjl2
%patch7 -p1 -b .jim
%ifarch sparc
%patch8 -p1 -b .sparc
%endif
%patch9 -p1 -b .haifa
%patch10 -p1 -b .thread
%ifarch mipseb mipsel mips
%patch11 -p1 -b .mips
%endif


%build
%ifarch mipseb
RPM_ARCH=mips
%else
RPM_ARCH=mipsel
%endif
rm -rf obj-$RPM_ARCH-linux
mkdir obj-$RPM_ARCH-linux
cd obj-$RPM_ARCH-linux
%ifarch sparc
CFLAGS="$RPM_OPT_FLAGS" ../configure  --prefix=/usr \
	--enable-shared --enable-haifa --enable-threads \
	$RPM_ARCH-redhat-linux-gnulibc1
%else
%ifarch mipseb mipsel mips
CFLAGS="$RPM_OPT_FLAGS" ../configure  --prefix=/usr \
	--enable-shared --enable-threads --disable-multilib \
	$RPM_ARCH-redhat-linux
%else
CFLAGS="$RPM_OPT_FLAGS" ../configure  --prefix=/usr \
	--enable-shared --enable-threads \
	$RPM_ARCH-redhat-linux
%endif
%endif
PATH=$PATH:/sbin:/usr/sbin
# gperf is most likely broken on alpha and sparc 
touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split" bootstrap-lean

%install
%ifarch mipseb
RPM_ARCH=mips
%else
RPM_ARCH=mipsel
%endif
rm -rf $RPM_BUILD_ROOT
cd obj-$RPM_ARCH-linux
PATH=$PATH:/sbin:/usr/sbin
make prefix=$RPM_BUILD_ROOT/usr MAKEINFO="makeinfo --no-split" install
# get rid of the texinfo crap
make prefix=$RPM_BUILD_ROOT/usr -C texinfo uninstall
FULLVER=`$RPM_BUILD_ROOT/usr/bin/$RPM_ARCH-redhat-linux*-gcc --version | cut -d' ' -f1`
FULLPATH=$(dirname $RPM_BUILD_ROOT/usr/lib/gcc-lib/$RPM_ARCH-*/$FULLVER/cc1)
strip $RPM_BUILD_ROOT/usr/bin/*

strip $FULLPATH/{cc1,cc1obj,cc1plus,cpp,f771,ld}

# fix some things
mv $RPM_BUILD_ROOT/usr/bin/$RPM_ARCH-redhat-linux*-gcc $RPM_BUILD_ROOT/usr/bin/$RPM_ARCH-redhat-linux-egcs
ln $RPM_BUILD_ROOT/usr/bin/$RPM_ARCH-redhat-linux-egcs $RPM_BUILD_ROOT/usr/bin/egcs
ln -sf gcc $RPM_BUILD_ROOT/usr/bin/cc
ln $RPM_BUILD_ROOT/usr/man/man1/gcc.1 $RPM_BUILD_ROOT/usr/man/man1/egcs.1

rm -f $RPM_BUILD_ROOT/usr/info/dir
sed "s/ gcc.info,/ egcs.info,/g" < $RPM_BUILD_ROOT/usr/info/gcc.info > $RPM_BUILD_ROOT/usr/info/egcs.info
gzip -n -9f $RPM_BUILD_ROOT/usr/info/*.info* 

ln -sf g77.1 $RPM_BUILD_ROOT/usr/man/man1/f77.1
ln -sf g77 $RPM_BUILD_ROOT/usr/bin/f77

mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ../${FULLPATH##$RPM_BUILD_ROOT/}/cpp $RPM_BUILD_ROOT/lib/cpp
mv $RPM_BUILD_ROOT/usr/lib/libf2c.a $FULLPATH

#ln -sf ../../$FULLPATH/cc1obj $RPM_BUILD_ROOT/usr/bin
ln -sf cccp.1 $RPM_BUILD_ROOT/usr/man/man1/cpp.1

%ifarch ppc
ln -sf libstdc++.so.2.8.0 ${RPM_BUILD_ROOT}/usr/lib/nof/libstdc++.so.2.8
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%ifarch i386
/sbin/install-info \
	--section="Programming:" --entry="*egcs:(egcs).                   The GNU C compiler." \
	--info-dir=/usr/info /usr/info/egcs.info.gz
%else
/sbin/install-info \
	--section="Programming:" --entry="*gcc:(gcc).                   The GNU C compiler." \
	--info-dir=/usr/info /usr/info/gcc.info.gz
%endif
/sbin/install-info \
	--section="Programming:" --entry="*cpp:(cpp).                   The C preprocessor." \
	--info-dir=/usr/info /usr/info/cpp.info.gz

%post g77 
/sbin/install-info \
	--section="Programming:" --entry="*g77:(g77).                     The GNU Fortran 77 compiler." \
	--info-dir=/usr/info /usr/info/g77.info.gz

%preun
if [ $1 = 0 ]; then
   /sbin/install-info --delete \
	--section="Programming:" --entry="*cpp:(cpp).                   The C preprocessor." \
	--info-dir=/usr/info /usr/info/cpp.info.gz
%ifarch i386
   /sbin/install-info --delete \
	--section="Programming:" --entry="*egcs:(egcs).                   The GNU C compiler." \
	--info-dir=/usr/info /usr/info/egcs.info.gz
%else
   /sbin/install-info --delete \
	--section="Programming:" --entry="*gcc:(gcc).                   The GNU C compiler." \
	--info-dir=/usr/info /usr/info/gcc.info.gz
%endif
fi

%preun g77
if [ $1 = 0 ]; then
   /sbin/install-info --delete \
	--section="Programming:" --entry="*g77:(g77).                     The GNU Fortran 77 compiler." \
	--info-dir=/usr/info /usr/info/g77.info.gz
fi

%post -n libstdc++ -p /sbin/ldconfig

%postun -n libstdc++ -p /sbin/ldconfig

%files
%doc README* COPYING COPYING.LIB
%dir /usr/lib/gcc-lib
%dir /usr/lib/gcc-lib/*-redhat-linux*
%dir /usr/lib/gcc-lib/*-redhat-linux*/egcs-*
%dir /usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include
/usr/bin/*-redhat-linux-egcs
/usr/bin/egcs
/usr/bin/gcov
/usr/bin/protoize
/usr/bin/unprotoize
%ifnarch i386
/usr/bin/gcc
/usr/bin/cc
/usr/man/man1/gcc.1
/usr/info/gcc*
%else
/usr/man/man1/egcs.1
/usr/info/egcs*
%endif
/lib/cpp
/usr/man/man1/cpp.1
/usr/man/man1/cccp.1
/usr/info/cpp.info*.gz
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/SYSCALLS.c.X
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/cc1
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/cpp
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/libgcc.a
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/specs
%ifnarch alpha
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/*.o
%endif
/usr/*-redhat-linux*
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/ld
%ifarch ppc
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/nof
%endif
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/README
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/float.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/iso646.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/limits.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/proto.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/stdarg.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/stddef.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/syslimits.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/va-*.h
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/varargs.h
%ifarch ppc
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/*-redhat-asm.h
%endif

%files c++
/usr/man/man1/g++.1
/usr/bin/g++
/usr/bin/c++
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/cc1plus
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/exception
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/new
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/typeinfo
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/new.h
%ifarch ppc
/usr/lib/nof
%endif

%files objc
#/usr/bin/cc1obj
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/cc1obj
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/libobjc.a
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/objc

%files g77
/usr/bin/g77
/usr/bin/f77
/usr/info/g77*
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/f771
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/libf2c.a
/usr/man/man1/g77.1
/usr/man/man1/f77.1
/usr/lib/gcc-lib/*-redhat-linux*/egcs-*/include/f2c.h

%files -n libstdc++-devel
/usr/include/g++
/usr/lib/libstdc++.a
/usr/lib/libstdc++.so
%ifarch ppc
/usr/lib/nof/libstdc++.a
/usr/lib/nof/libstdc++.so
%endif

%files -n libstdc++
/usr/lib/libstdc++.so.2.8.0
%ifarch ppc
/usr/lib/nof/libstdc++.so.2.8
/usr/lib/nof/libstdc++.so.2.8.0
%endif
